package MakeWorld::Mogrify::MkPath;

use strict;
use warnings;

use File::Path qw[ mkpath ];

use MakeWorld::Global;
use MakeWorld::Check qw[ check %BOOLEAN ];
use MakeWorld::Run;
use MakeWorld::Log;

################################################################################
# execute a command

sub verify {

    my ( $class, $opts, $need_hook ) = @_;

    return check( {
		   arg => { required => 1, default => [] },
		   hook => { required => $need_hook },
		  }, $opts
		);
}


sub mogrify
{
    my ( $class, $pkg, $opts ) = @_;

    msgp( "<mkpath>", MakeWorld::Log::Info, $opts->{arg} );

    my $errors;
    mkpath( @{ $opts->{arg} }, { error => \$errors } );

    die( "<mkpath>:\n", map { @_ = %$_; "$_->[0]: $_->[1]\n" } @$errors )
      if @$errors;

    return;
}

1;
